Subject: Re: [PATCH] powerpc: Add support for using doorbells for SMP IPI

From: Benjamin Herrenschmidt <[email-masked]>
Date: Fri, 13 Feb 2009 13:46:40 +1100

On Thu, 2009-02-12 at 17:54 -0600, Kumar Gala wrote:
> The e500mc supports the new msgsnd/doorbell mechanisms that were added in
> the Power ISA 2.05 architecture.  We use the normal level doorbell for
> doing SMP IPIs at this point.
> 

Cool stuff. Haven't reviewed in details yet tho :-) But I was
thinking...

We should introduce a special xmon variant of local_irq_save/restore for
use by xmon that masks MSR:CE and use a crit doorbell for xmon IPI, that
would increase significantly the ability of xmon to catch deadlocked
CPUs, and we could use external CRITs as a more generic way of doing
IPIs, no ?

In fact, we should expose a local_crit_irq_save/restore (disable/enable)
too for things like watchdog drivers etc... which may want to use these.

Cheers,
Ben.